options NOXWAIT;run;
x 'dir H:\IO\ > C:\Users\qz17d6\sas\listsas.txt';
run;

Data fillstS2;
	infile "C:\Users\qz17d6\sas\listsas.txt" truncover;
	length var1 $80.;
	Input @1 var1 $80.;

	if index(var1,'dflist')>0  then
		do;
			FilNam= substr(var1,index(var1,'dflist'),20);
			output;
		end;
	else delete;
	drop var1;
run;

proc print data=fillstS2;
run;


proc datasets ;  delete widgit_count ;   run; 
	*clean up data set for append below;
%macro readfil (var) ;
DATA temp;
    LENGTH        Count   3  order_cd $3  Unit_NM $15 ;
    FORMAT        Count   3. order_cd $3. Unit_NM $15. ;
    INFORMAT      Count   3. order_cd $3. Unit_NM $15. ;
    INFILE "H:\IO\&var"
        LRECL=100
        TRUNCOVER ;
    INPUT
        @1 count 3. 
		@5 order_cd $3.         ;
		Unit_nm="&var" ; 
		UNIT_NAME=upcase(unit_nm); drop UNIT_nm; 
RUN;
proc append base=widgit_count data=temp force; 
%mend readfil; run; 

data _null_ ; 
 set fillstS2  ; * data set containing the names of the text file to be passed; 
 	* text file name found in varname: FilNam ; 
  call execute  ( '%readfil   ( %str(' ||compress(FilNam)|| ')   ) '  ) ;  
run; 

proc contents data=widgit_count ; run;

proc print data=widgit_count(obs=10) ; run;

proc summary data=widgit_count nway missing; 
 class UNIT_NAME order_cd ;
var count;
output sum= out=final_rpt;   
 run;
 proc print data=final_rpt; 
ID unit_name ; 
var order_cd count ; run; 
